searchNodes=[{"doc":"A LinkedMapSet is an extension to MapSet that keeps pointers to previous and next elements based on add order.","ref":"LinkedMapSet.html","title":"LinkedMapSet","type":"module"},{"doc":"Adds an item to the linked map, or moves an existing one to tail.Returns the updated LinkedMapSet.Examplesiex&gt; LinkedMapSet.new() |&gt; LinkedMapSet.add(&quot;foo&quot;) iex&gt; LinkedMapSet.new |&gt; LinkedMapSet.add(&quot;foo&quot;) |&gt; LinkedMapSet.add(&quot;bar&quot;) %LinkedMapSet{ head: &quot;foo&quot;, items: %{ &quot;bar&quot; =&gt; %Node{next: nil, previous: &quot;foo&quot;, value: &quot;bar&quot;}, &quot;foo&quot; =&gt; %Node{next: &quot;bar&quot;, previous: nil, value: &quot;foo&quot;} }, tail: &quot;bar&quot; }","ref":"LinkedMapSet.html#add/2","title":"LinkedMapSet.add/2","type":"function"},{"doc":"Adds a new item to the linked map, unless it already exists.Returns the updated LinkedMapSet.Examplesiex&gt; LinkedMapSet.new() |&gt; LinkedMapSet.add(&quot;a&quot;) |&gt; LinkedMapSet.add_new(&quot;a&quot;) %LinkedMapSet{ head: &quot;a&quot;, items: %{ &quot;a&quot; =&gt; %Node{next: nil, previous: nil, value: &quot;a&quot;} }, tail: &quot;a&quot; }","ref":"LinkedMapSet.html#add_new/2","title":"LinkedMapSet.add_new/2","type":"function"},{"doc":"Adds a new item to the linked map, or raises if value already exists.Returns the updated LinkedMapSet or raises if value already exists.Behaves the same as add_new/2 but raises if value already exists.Examplesiex&gt; LinkedMapSet.new() |&gt; LinkedMapSet.add(&quot;a&quot;) |&gt; LinkedMapSet.add_new!(&quot;a&quot;) ** (LinkedMapSet.DuplicateValueError) value &quot;a&quot; is already present","ref":"LinkedMapSet.html#add_new!/2","title":"LinkedMapSet.add_new!/2","type":"function"},{"doc":"Returns whether the given value exists in the given linked_map_set.Examplesiex&gt; LinkedMapSet.new() |&gt; LinkedMapSet.add(&quot;a&quot;) |&gt; LinkedMapSet.member?(&quot;a&quot;) true iex&gt; LinkedMapSet.new() |&gt; LinkedMapSet.add(&quot;a&quot;) |&gt; LinkedMapSet.member?(&quot;b&quot;) false","ref":"LinkedMapSet.html#member?/2","title":"LinkedMapSet.member?/2","type":"function"},{"doc":"Create a new LinkedMapSetReturns a new empty LinkedMapSet.Examplesiex&gt; LinkedMapSet.new() %LinkedMapSet{head: nil, items: %{}, tail: nil}","ref":"LinkedMapSet.html#new/0","title":"LinkedMapSet.new/0","type":"function"},{"doc":"Remove an item from the linked map if it exists.Returns the updated LinkedMapSet.Examplesiex&gt; linked_map_set = LinkedMapSet.new |&gt; LinkedMapSet.add(&quot;a&quot;) |&gt; LinkedMapSet.add(&quot;b&quot;) |&gt; LinkedMapSet.add(&quot;c&quot;) %LinkedMapSet{ head: &quot;a&quot;, items: %{ &quot;a&quot; =&gt; %Node{next: &quot;b&quot;, previous: nil, value: &quot;a&quot;}, &quot;b&quot; =&gt; %Node{next: &quot;c&quot;, previous: &quot;a&quot;, value: &quot;b&quot;}, &quot;c&quot; =&gt; %Node{next: nil, previous: &quot;b&quot;, value: &quot;c&quot;} }, tail: &quot;c&quot; } iex&gt; LinkedMapSet.remove(linked_map_set, &quot;b&quot;) %LinkedMapSet{ head: &quot;a&quot;, items: %{ &quot;a&quot; =&gt; %Node{next: &quot;c&quot;, previous: nil, value: &quot;a&quot;}, &quot;c&quot; =&gt; %Node{next: nil, previous: &quot;a&quot;, value: &quot;c&quot;} }, tail: &quot;c&quot; }","ref":"LinkedMapSet.html#remove/2","title":"LinkedMapSet.remove/2","type":"function"},{"doc":"Removes an item from the linked map, or raises if it doesn't exist.Returns the updated LinkedMapSet, or raises if value doesn't exist.Behavies the same as remove/2, but raises if value doesn't exist.Examplesiex&gt; LinkedMapSet.new() |&gt; LinkedMapSet.add(&quot;a&quot;) |&gt; LinkedMapSet.remove!(&quot;b&quot;) ** (LinkedMapSet.MissingValueError) value &quot;b&quot; is not present","ref":"LinkedMapSet.html#remove!/2","title":"LinkedMapSet.remove!/2","type":"function"},{"doc":"Returns the number of items in the linked_map_set.Examplesiex&gt; LinkedMapSet.new() |&gt; LinkedMapSet.add(&quot;a&quot;) |&gt; LinkedMapSet.size() 1","ref":"LinkedMapSet.html#size/1","title":"LinkedMapSet.size/1","type":"function"},{"doc":"Returns the values as a List in order.Examplesiex&gt; LinkedMapSet.new() |&gt; LinkedMapSet.add(&quot;a&quot;) |&gt; LinkedMapSet.add(&quot;b&quot;) |&gt; LinkedMapSet.to_list()","ref":"LinkedMapSet.html#to_list/1","title":"LinkedMapSet.to_list/1","type":"function"},{"doc":"","ref":"LinkedMapSet.html#t:t/0","title":"LinkedMapSet.t/0","type":"type"},{"doc":"LinkedMapSetA LinkedMapSet is an extension to MapSet that maintains ordering.It does this by keeping pointers to previous and next elements based on insert order.I built this to have a collection I can traverse in either direction, but also be able to remove items in less-than-linear time. I also didn't want something that needed to be sorted or rebalanced after each addition or removal.This uses Map underneath, much like MapSet, so removing arbitrary items can happen in logarithmic time, rather than linear time that most sorted collections incur.","ref":"readme.html","title":"LinkedMapSet","type":"extras"},{"doc":"def deps do [ {:linked_map_set, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"LinkedMapSet - Installation","type":"extras"},{"doc":"See the documentation for API reference and examples.","ref":"readme.html#usage","title":"LinkedMapSet - Usage","type":"extras"}]